码迷,mamicode.com
首页 > 其他好文 > 详细

poj3126——Prime Path(BFS)

时间:2016-07-30 12:13:16      阅读:179      评论:0      收藏:0      [点我收藏+]

标签:

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input

3
1033 8179
1373 8017
1033 1033
Sample Output

6
7
0

一个四位素数变化成另一个四位素数,每次只能改变一位且改变后的数字也是素数,求最少需要改变多少次。
放在搜索分类下我才知道要用BFS。。。

#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <algorithm>
#define INF 0x3f3f3f3f
#define MAXN 1010
using namespace std;
struct Node
{
    int a[4],step;
};
int primer[3000],cnt,vis[10000];
bool flag;
bool judge(int n)
{
    for(int i=2; i*i<=n; ++i)
        if(n%i==0)
            return false;
    return true;
}
void bfs(Node start,int m)
{
    queue<Node> q;
    q.push(start);
    while(!q.empty())
    {
        Node tmp=q.front(),tmp1;
        q.pop();
        int mm=tmp.a[0]*1000+tmp.a[1]*100+tmp.a[2]*10+tmp.a[3];
        //cout<<"mm="<<mm<<endl;
        if(mm==m)
        {
            cout<<tmp.step<<endl;
            flag=true;
            break;
        }
        tmp1=tmp;
        for(int i=1; i<=9; ++i)
        {
            tmp1.a[0]=i;
            int t=tmp1.a[0]*1000+tmp1.a[1]*100+tmp1.a[2]*10+tmp1.a[3];
            if(judge(t)&&!vis[t])
            {
                //cout<<"t0="<<t<<endl;
                vis[t]=1;
                tmp1.step=tmp.step+1;
                q.push(tmp1);
            }
            tmp1=tmp;
        }
        for(int i=0; i<=9; ++i)
        {
            for(int j=1; j<4; ++j)
            {
                tmp1.a[j]=i;
                int t=tmp1.a[0]*1000+tmp1.a[1]*100+tmp1.a[2]*10+tmp1.a[3];
                if(judge(t)&&!vis[t])
                {
                    //cout<<"t="<<t<<endl;
                    vis[t]=1;
                    tmp1.step=tmp.step+1;
                    q.push(tmp1);
                }
                tmp1=tmp;
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    int t,n,m;
    cin>>t;
    while(t--)
    {
        flag=false;
        memset(vis,0,sizeof(vis));
        cin>>n>>m;
        Node start;
        start.a[0]=n/1000;
        start.a[1]=(n/100)%10;
        start.a[2]=(n/10)%10;
        start.a[3]=n%10;
        start.step=0;
        bfs(start,m);
        if(!flag)
            cout<<"Impossible"<<endl;
    }
    return 0;
}

poj3126——Prime Path(BFS)

标签:

原文地址:http://blog.csdn.net/blue_skyrim/article/details/52071700

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!